"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatboxWithGuards = void 0;
const react_1 = require("@chakra-ui/react");
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const wallet_adapter_react_ui_1 = require("@solana/wallet-adapter-react-ui");
const react_2 = require("@strata-foundation/react");
const spl_token_bonding_1 = require("@strata-foundation/spl-token-bonding");
const hooks_1 = require("../../hooks");
const react_3 = __importStar(require("react"));
const hooks_2 = require("../../hooks");
const useChatOwnedAmount_1 = require("../../hooks/useChatOwnedAmount");
const BuyMoreButton_1 = require("../BuyMoreButton");
const LoadWalletModal_1 = require("../LoadWalletModal");
const MyFlex_1 = require("../MyFlex");
const Chatbox_1 = require("./Chatbox");
const DARK_BG = {
    bg: "linear-gradient(0deg, rgba(17,24,39) 40%, rgba(21,24,38,0) 100%)",
};
function ChatboxWithGuards({ scrollRef, chatKey, onAddPendingMessage, files, setFiles, onUploadFile, }) {
    const myScrollRef = (0, react_3.useRef)(null);
    if (!scrollRef)
        scrollRef = myScrollRef;
    const { isOpen: loadWalletIsOpen, onOpen: onOpenLoadWallet, onClose: onCloseLoadWallet, } = (0, react_1.useDisclosure)();
    const { connected, publicKey } = (0, wallet_adapter_react_1.useWallet)();
    const { setVisible } = (0, wallet_adapter_react_ui_1.useWalletModal)();
    const { delegateWallet, needsTopOff, needsInit, loading: loadingDelegate, error: delegateError, } = (0, hooks_2.useLoadDelegate)();
    const { isOpen: delegateIsOpen, onClose: closeDelegate, onOpen: openDelegate, } = (0, react_1.useDisclosure)({
        defaultIsOpen: false,
    });
    const { handleErrors } = (0, react_2.useErrorHandler)();
    const { info: chatPermissions } = (0, hooks_1.useChatPermissionsFromChat)(chatKey);
    const { metadata: readMetadata, image: readImage } = (0, react_2.useTokenMetadata)(chatPermissions === null || chatPermissions === void 0 ? void 0 : chatPermissions.readPermissionKey);
    const { metadata: postMetadata, image: postImage } = (0, react_2.useTokenMetadata)(chatPermissions === null || chatPermissions === void 0 ? void 0 : chatPermissions.postPermissionKey);
    const { amount: ownedAmount } = (0, useChatOwnedAmount_1.useChatOwnedAmount)(publicKey || undefined, chatKey);
    const mint = (0, react_2.useMint)(chatPermissions === null || chatPermissions === void 0 ? void 0 : chatPermissions.postPermissionKey);
    const postAmount = (chatPermissions === null || chatPermissions === void 0 ? void 0 : chatPermissions.postPermissionAmount) &&
        mint &&
        (0, spl_token_bonding_1.toNumber)(chatPermissions === null || chatPermissions === void 0 ? void 0 : chatPermissions.postPermissionAmount, mint);
    const hasEnough = typeof postAmount == "undefined" ||
        typeof ownedAmount == "undefined" ||
        ownedAmount >= postAmount;
    handleErrors(delegateError);
    return (react_3.default.createElement(MyFlex_1.Flex, { w: "full", position: "relative" }, !connected || !hasEnough || needsTopOff ? (react_3.default.createElement(MyFlex_1.Flex, { position: "absolute", bottom: "0", pb: 12, pt: 40, w: "full", justify: "center", bg: "linear-gradient(0deg, rgba(255,255,255) 40%, rgba(255,255,255,0) 100%)", _dark: DARK_BG },
        react_3.default.createElement(react_1.VStack, { w: "full", h: "full", justify: "center", align: "center", maxW: "360px" }, !connected ? (react_3.default.createElement(react_3.default.Fragment, null,
            react_3.default.createElement(react_1.Button, { size: "md", colorScheme: "primary", onClick: () => setVisible(true), px: 16 }, "Connect Wallet"))) : !hasEnough ? (react_3.default.createElement(react_3.default.Fragment, null,
            react_3.default.createElement(react_1.Text, { fontWeight: "bold", align: "center" }, "In order to participate in this chat:"),
            react_3.default.createElement(react_1.Box, { w: "full", fontSize: "sm" },
                readMetadata && (react_3.default.createElement(react_1.HStack, { spacing: 1 },
                    react_3.default.createElement(react_1.Text, null, "Read Message"),
                    react_3.default.createElement(MyFlex_1.Flex, { grow: 1 },
                        react_3.default.createElement(react_1.Divider, { variant: "dashed" })),
                    react_3.default.createElement(react_1.Text, { fontWeight: "bold", textTransform: "capitalize" }, "Hold 1"),
                    react_3.default.createElement(react_1.Avatar, { w: "18px", h: "18px", title: readMetadata === null || readMetadata === void 0 ? void 0 : readMetadata.data.symbol, src: readImage }))),
                postMetadata && (react_3.default.createElement(react_1.HStack, { spacing: 1 },
                    react_3.default.createElement(react_1.Text, null, "Post Message"),
                    react_3.default.createElement(MyFlex_1.Flex, { grow: 1 },
                        react_3.default.createElement(react_1.Divider, { variant: "dashed" })),
                    react_3.default.createElement(react_1.Text, { fontWeight: "bold", textTransform: "capitalize" },
                        Object.keys((chatPermissions === null || chatPermissions === void 0 ? void 0 : chatPermissions.postPermissionAction) || {})[0],
                        " ",
                        postAmount),
                    react_3.default.createElement(react_1.Avatar, { w: "18px", h: "18px", title: postMetadata === null || postMetadata === void 0 ? void 0 : postMetadata.data.symbol, src: postImage })))),
            react_3.default.createElement(react_1.Box, { w: "full", fontSize: "sm" }, readMetadata && (react_3.default.createElement(react_1.HStack, { spacing: 1 },
                react_3.default.createElement(react_1.Text, null, "You currently have"),
                react_3.default.createElement(MyFlex_1.Flex, { grow: 1 },
                    react_3.default.createElement(react_1.Divider, { variant: "dashed" })),
                react_3.default.createElement(react_1.Text, { fontWeight: "bold", textTransform: "capitalize" }, ownedAmount ? (0, react_2.roundToDecimals)(ownedAmount, 4) : 0),
                react_3.default.createElement(react_1.Avatar, { w: "18px", h: "18px", title: readMetadata === null || readMetadata === void 0 ? void 0 : readMetadata.data.symbol, src: readImage })))),
            react_3.default.createElement(react_1.Box, { pt: 4 },
                react_3.default.createElement(BuyMoreButton_1.BuyMoreButton, { mint: chatPermissions === null || chatPermissions === void 0 ? void 0 : chatPermissions.postPermissionKey, btnProps: { px: 16, size: "md", variant: "solid" } })))) : needsTopOff ? (react_3.default.createElement(react_3.default.Fragment, null,
            react_3.default.createElement(LoadWalletModal_1.LoadWalletModal, { isOpen: loadWalletIsOpen, onClose: onCloseLoadWallet, onLoaded: () => onCloseLoadWallet() }),
            react_3.default.createElement(MyFlex_1.Flex, { justify: "center", mb: "6px" },
                react_3.default.createElement(react_1.Button, { isLoading: loadingDelegate, size: "md", colorScheme: "primary", onClick: () => onOpenLoadWallet(), px: 16 }, "Top Off Chat Wallet")))) : null))) : (react_3.default.createElement(react_1.VStack, { w: "full" },
        !delegateWallet && (react_3.default.createElement(react_1.HStack, { mb: -3, mt: 1, fontSize: "sm" },
            react_3.default.createElement(react_1.Text, { fontWeight: "bold" }, "Tired of approving transactions?"),
            react_3.default.createElement(react_1.Button, { fontSize: "sm", variant: "link", size: "md", colorScheme: "primary", onClick: () => openDelegate(), px: 16 }, "Load Delegate Wallet"))),
        (needsTopOff || needsInit) && (react_3.default.createElement(LoadWalletModal_1.LoadWalletModal, { isOpen: delegateIsOpen, onClose: closeDelegate, onLoaded: closeDelegate })),
        react_3.default.createElement(Chatbox_1.Chatbox, { scrollRef: scrollRef, chatKey: chatKey, onAddPendingMessage: onAddPendingMessage, files: files, setFiles: setFiles, onUploadFile: onUploadFile })))));
}
exports.ChatboxWithGuards = ChatboxWithGuards;
//# sourceMappingURL=ChatboxWithGuards.js.map